- todo = issuable_todo(issuable)
- content_for :page_specific_javascripts do
  = page_specific_javascript_bundle_tag('issuable')

%aside.right-sidebar.js-right-sidebar{ data: { "offset-top" => "101", "spy" => "affix" }, class: sidebar_gutter_collapsed_class, 'aria-live' => 'polite' }
  .issuable-sidebar
    - can_edit_issuable = can?(current_user, :"admin_#{issuable.to_ability_name}", @project)
    .block.issuable-sidebar-header
      - if current_user
        %span.issuable-header-text.hide-collapsed.pull-left
          Todo
      %a.gutter-toggle.pull-right.js-sidebar-toggle{ role: "button", href: "#", "aria-label" => "Toggle sidebar" }
        = sidebar_gutter_toggle_icon
      - if current_user
        %button.btn.btn-default.issuable-header-btn.pull-right.js-issuable-todo{ type: "button", "aria-label" => (todo.nil? ? "Add todo" : "Mark done"), data: { todo_text: "Add todo", mark_text: "Mark done", issuable_id: issuable.id, issuable_type: issuable.class.name.underscore, url: namespace_project_todos_path(@project.namespace, @project), delete_path: (dashboard_todo_path(todo) if todo) } }
          %span.js-issuable-todo-text
            - if todo
              Mark done
            - else
              Add todo
          = icon('spin spinner', class: 'hidden js-issuable-todo-loading', 'aria-hidden': 'true')

    = form_for [@project.namespace.becomes(Namespace), @project, issuable], remote: true, format: :json, html: { class: 'issuable-context-form inline-update js-issuable-update' } do |f|
      .block.assignee
        .sidebar-collapsed-icon.sidebar-collapsed-user{ data: { toggle: "tooltip", placement: "left", container: "body" }, title: (issuable.assignee.name if issuable.assignee) }
          - if issuable.assignee
            = link_to_member(@project, issuable.assignee, size: 24)
          - else
            = icon('user', 'aria-hidden': 'true')
        .title.hide-collapsed
          Assignee
          = icon('spinner spin', class: 'block-loading', 'aria-hidden': 'true')
          - if can_edit_issuable
            = link_to 'Edit', '#', class: 'edit-link pull-right'
        .value.hide-collapsed
          - if issuable.assignee
            = link_to_member(@project, issuable.assignee, size: 32, extra_class: 'bold') do
              - if issuable.instance_of?(MergeRequest) && !issuable.can_be_merged_by?(issuable.assignee)
                %span.pull-right.cannot-be-merged{ data: { toggle: 'tooltip', placement: 'left' }, title: 'Not allowed to merge' }
                  = icon('exclamation-triangle', 'aria-hidden': 'true')
              %span.username
                = issuable.assignee.to_reference
          - else
            %span.assign-yourself.no-value
              No assignee
              - if can_edit_issuable
                \-
                %a.js-assign-yourself{ href: '#' }
                  assign yourself

        .selectbox.hide-collapsed
          = f.hidden_field 'assignee_id', value: issuable.assignee_id, id: 'issue_assignee_id'
          = dropdown_tag('Select assignee', options: { toggle_class: 'js-user-search js-author-search', title: 'Assign to', filter: true, dropdown_class: 'dropdown-menu-user dropdown-menu-selectable dropdown-menu-author', placeholder: 'Search users', data: { first_user: (current_user.username if current_user), current_user: true, project_id: (@project.id if @project), author_id: issuable.author_id, field_name: "#{issuable.to_ability_name}[assignee_id]", issue_update: issuable_json_path(issuable), ability_name: issuable.to_ability_name, null_user: true } })

      .block.milestone
        .sidebar-collapsed-icon
          = icon('clock-o', 'aria-hidden': 'true')
          %span
            - if issuable.milestone
              %span.has-tooltip{ title: milestone_remaining_days(issuable.milestone), data: { container: 'body', html: 1, placement: 'left' } }
                = issuable.milestone.title
            - else
              None
        .title.hide-collapsed
          Milestone
          = icon('spinner spin', class: 'block-loading', 'aria-hidden': 'true')
          - if can_edit_issuable
            = link_to 'Edit', '#', class: 'edit-link pull-right'
        .value.hide-collapsed
          - if issuable.milestone
            = link_to issuable.milestone.title, namespace_project_milestone_path(@project.namespace, @project, issuable.milestone), class: "bold has-tooltip", title: milestone_remaining_days(issuable.milestone), data: { container: "body", html: 1 }
          - else
            %span.no-value None

        .selectbox.hide-collapsed
          = f.hidden_field 'milestone_id', value: issuable.milestone_id, id: nil
          = dropdown_tag('Milestone', options: { title: 'Assign milestone', toggle_class: 'js-milestone-select js-extra-options', filter: true, dropdown_class: 'dropdown-menu-selectable', placeholder: 'Search milestones', data: { show_no: true, field_name: "#{issuable.to_ability_name}[milestone_id]", project_id: @project.id, issuable_id: issuable.id, milestones: namespace_project_milestones_path(@project.namespace, @project, :json), ability_name: issuable.to_ability_name, issue_update: issuable_json_path(issuable), use_id: true }})
      - if issuable.has_attribute?(:time_estimate)
        #issuable-time-tracker.block
          %issuable-time-tracker{ ':time_estimate' => 'issuable.time_estimate', ':time_spent' => 'issuable.total_time_spent', ':human_time_estimate' => 'issuable.human_time_estimate', ':human_time_spent' => 'issuable.human_total_time_spent', 'stopwatch-svg' => custom_icon('icon_stopwatch'), 'docs-url' => help_page_path('workflow/time_tracking.md') }
            // Fallback while content is loading
            .title.hide-collapsed
              Time tracking
              = icon('spinner spin', 'aria-hidden': 'true')
      - if issuable.has_attribute?(:due_date)
        .block.due_date
          .sidebar-collapsed-icon
            = icon('calendar', 'aria-hidden': 'true')
            %span.js-due-date-sidebar-value
              = issuable.due_date.try(:to_s, :medium) || 'None'
          .title.hide-collapsed
            Due date
            = icon('spinner spin', class: 'block-loading', 'aria-hidden': 'true')
            - if can?(current_user, :"admin_#{issuable.to_ability_name}", @project)
              = link_to 'Edit', '#', class: 'edit-link pull-right'
          .value.hide-collapsed
            %span.value-content
              - if issuable.due_date
                %span.bold= issuable.due_date.to_s(:medium)
              - else
                %span.no-value No due date
            - if can?(current_user, :"admin_#{issuable.to_ability_name}", @project)
              %span.no-value.js-remove-due-date-holder{ class: ("hidden" if issuable.due_date.nil?) }
                \-
                %a.js-remove-due-date{ href: "#", role: "button" }
                  remove due date
          - if can?(current_user, :"admin_#{issuable.to_ability_name}", @project)
            .selectbox.hide-collapsed
              = f.hidden_field :due_date, value: issuable.due_date.try(:strftime, 'yy-mm-dd')
              .dropdown
                %button.dropdown-menu-toggle.js-due-date-select{ type: 'button', data: { toggle: 'dropdown', field_name: "#{issuable.to_ability_name}[due_date]", ability_name: issuable.to_ability_name, issue_update: issuable_json_path(issuable) } }
                  %span.dropdown-toggle-text Due date
                  = icon('chevron-down', 'aria-hidden': 'true')
                .dropdown-menu.dropdown-menu-due-date
                  = dropdown_title('Due date')
                  = dropdown_content do
                    .js-due-date-calendar

      - if @labels && @labels.any?
        - selected_labels = issuable.labels
        .block.labels
          .sidebar-collapsed-icon.js-sidebar-labels-tooltip{ title: issuable_labels_tooltip(issuable.labels_array), data: { placement: "left", container: "body" } }
            = icon('tags', 'aria-hidden': 'true')
            %span
              = selected_labels.size
          .title.hide-collapsed
            Labels
            = icon('spinner spin', class: 'block-loading', 'aria-hidden': 'true')
            - if can_edit_issuable
              = link_to 'Edit', '#', class: 'edit-link pull-right'
          .value.issuable-show-labels.hide-collapsed{ class: ("has-labels" if selected_labels.any?) }
            - if selected_labels.any?
              - selected_labels.each do |label|
                = link_to_label(label, subject: issuable.project, type: issuable.to_ability_name)
            - else
              %span.no-value None
          .selectbox.hide-collapsed
            - selected_labels.each do |label|
              = hidden_field_tag "#{issuable.to_ability_name}[label_names][]", label.id, id: nil
            .dropdown
              %button.dropdown-menu-toggle.js-label-select.js-multiselect.js-label-sidebar-dropdown{ type: "button", data: {toggle: "dropdown", default_label: "Labels", field_name: "#{issuable.to_ability_name}[label_names][]", ability_name: issuable.to_ability_name, show_no: "true", show_any: "true", namespace_path: @project.try(:namespace).try(:path), project_path: @project.try(:path), issue_update: issuable_json_path(issuable), labels: (namespace_project_labels_path(@project.namespace, @project, :json) if @project) } }
                %span.dropdown-toggle-text{ class: ("is-default" if selected_labels.empty?) }
                  = multi_label_name(selected_labels, "Labels")
                = icon('chevron-down', 'aria-hidden': 'true')
              .dropdown-menu.dropdown-select.dropdown-menu-paging.dropdown-menu-labels.dropdown-menu-selectable
                = render partial: "shared/issuable/label_page_default"
                - if can? current_user, :admin_label, @project and @project
                  = render partial: "shared/issuable/label_page_create"

      - if issuable.respond_to?(:weight)
        .block.weight
          .sidebar-collapsed-icon
            = icon('balance-scale')
            %span
              - if issuable.weight
                = issuable.weight
              - else
                No
          .title.hide-collapsed
            Weight
            = icon('spinner spin', class: 'block-loading')
            - if can?(current_user, :"admin_#{issuable.to_ability_name}", @project)
              = link_to 'Edit', '#', class: 'edit-link pull-right'
          .value.bold.hide-collapsed
            - if issuable.weight
              = issuable.weight
            - else
              .light None
          .selectbox.hide-collapsed
            = weight_dropdown_tag(issuable, title: 'Change weight', data: { field_name: 'weight', issue_update: "#{issuable_json_path(issuable)}", ability_name: "#{issuable.to_ability_name}" }) do
              %ul
                - Issue.weight_options.each do |weight|
                  %li
                    %a{ href: "#", data: { id: weight, none: weight == Issue::WEIGHT_NONE }, class: ("is-active" if params[:weight] == weight.to_s) }
                      = weight

      = render "shared/issuable/participants", participants: issuable.participants(current_user)
      - if current_user
        - subscribed = issuable.subscribed?(current_user, @project)
        .block.light.subscription{ data: { url: toggle_subscription_path(issuable) } }
          .sidebar-collapsed-icon
            = icon('rss', 'aria-hidden': 'true')
          %span.issuable-header-text.hide-collapsed.pull-left
            Notifications
          - subscribtion_status = subscribed ? 'subscribed' : 'unsubscribed'
          %button.btn.btn-default.pull-right.js-subscribe-button.issuable-subscribe-button.hide-collapsed{ type: "button" }
            %span= subscribed ? 'Unsubscribe' : 'Subscribe'

      - project_ref = cross_project_reference(@project, issuable)
      .block.project-reference
        .sidebar-collapsed-icon.dont-change-state
          = clipboard_button(clipboard_text: project_ref, title: "Copy reference to clipboard", placement: "left")
        .cross-project-reference.hide-collapsed
          %span
            Reference:
            %cite{ title: project_ref }
              = project_ref
          = clipboard_button(clipboard_text: project_ref, title: "Copy reference to clipboard", placement: "left")

    :javascript
      gl.IssuableResource = new gl.SubbableResource('#{issuable_json_path(issuable)}');
      new gl.IssuableTimeTracking("#{escape_javascript(serialize_issuable(issuable))}");
      new MilestoneSelect('{"full_path":"#{@project.full_path}"}');
      new LabelsSelect();
      new WeightSelect();
      new IssuableContext('#{escape_javascript(current_user.to_json(only: [:username, :id, :name]))}');
      gl.Subscription.bindAll('.subscription');
      new gl.DueDateSelectors();
      window.sidebar = new Sidebar();
